AchievementLooseHands = class(Turbine.UI.Control)
function AchievementLooseHands:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["In the Fray"] = true,
    }

    self.handler = handler
    self.player = Turbine.Gameplay.LocalPlayer.GetInstance()
    self.playerName = self.player:GetName()

    self.effectCallback = AddCallback(PlayerEffectsHandler, "EffectAdded", function(effect)
        if self.skillList[effect:GetName()] then
            if self.player:GetLevel() > 10 then
                handler:Fail("Loose Hands", "Went into ranged stance", 0x410E0DCA)
            else
                ChatOutput("Please switch away from ranged stance, reaching a higher level will cause you to fail this achievement!")
            end
        end
    end)

    self.command = Turbine.ShellCommand()
    function self.command:Execute()
        HardcoreHandler:GetAchievementHint("Loose Hands")
    end

    Turbine.Shell.AddCommand("hardcoreloosehands", self.command)

    ChatOutput("Use the command /hardcoreloosehands to see a list of affected skills")

    self.levelCallback = AddCallback(PlayerHandler, "LevelChanged", function(args)
        self:InitialState()
    end)

    self:InitialState()
end

function AchievementLooseHands:InitialState()
    for i = 1, PlayerEffectsHandler:GetPlayerEffects():GetCount() do
        if self.skillList[PlayerEffectsHandler:GetPlayerEffects():Get(i):GetName()] then 

            if self.player:GetLevel() > 10 then
                self.handler:Fail("Loose Hands", "Went into ranged stance", 0x410E0DCA)
            else
                ChatOutput("Please switch away from ranged stance, reaching a higher level will cause you to fail this achievement!")
            end
        end
    end
end

function AchievementLooseHands:Unload()
    RemoveCallback(PlayerEffectsHandler, "EffectAdded", self.effectCallback)
    RemoveCallback(PlayerHandler, "LevelChanged", self.levelCallback)
end

function AchievementLooseHands:GetHint()
    ChatOutput("<rgb=#005500>Only ranged stance is allowed.")
end